/*
 *   Copyright (c) 1993 by
 *   PARALLAX GRAPHICS, INCORPORATED, Santa Clara, California.
 *   All rights reserved
 *
 *   This software is furnished on an as-is basis, and may be used and copied
 *   only with the inclusion of the above copyright notice.
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 *   Author: George Drapeau
 */
/* $Header: /plx/S/source/Xclients/solaris2.4/3.4.new/RCS/XVideoOutP.h,v 1.14 1994/08/27 05:39:54 drapeau Exp $ */
/* $Log: XVideoOutP.h,v $
 * Revision 1.14  1994/08/27  05:39:54  drapeau
 * Deleted a function prototype since they are now all included by
 * XPlxExt.h, which includes XPlxProtos.h.
 *
 * Revision 1.13  1994/05/03  17:57:33  drapeau
 * Added a resource called "diagnostics"; when set, the widget will print
 * diagnostic messages about itself to aid in debugging.
 *
 * Revision 1.12  1994/03/14  04:03:41  drapeau
 * Added a new, private resource, "outputWindow", more cleanly to support
 * video output and disabling of such.
 *
 * Revision 1.11  1993/12/15  23:24:40  drapeau
 * Added a field to store the height of the blanking interval for the
 * video signal being produced.
 *
 * Revision 1.10  1993/09/10  12:15:43  drapeau
 * This is the first public release of the VideoOut widget header files.
 * */
static char xVideoOutPHeaderRcsId[] = "$Header: /plx/S/source/Xclients/solaris2.4/3.4.new/RCS/XVideoOutP.h,v 1.14 1994/08/27 05:39:54 drapeau Exp $";

#ifndef _XVideoOutP_h
#define _XVideoOutP_h

#include <XVideoOut.h>
#include <X11/CoreP.h>						    /* Include superclass private header file */
#include <XPlxExt.h>						    /* Include file for X extensions for Parallax video */


/* define unique representation types not found in <X11/StringDefs.h> */

#define XtRXVideoOutResource "XVideoOutResource"


typedef struct
{
  int empty;
} XVideoOutClassPart;

typedef struct _XVideoOutClassRec
{
  CoreClassPart		core_class;
  XVideoOutClassPart	xVideoOut_class;
} XVideoOutClassRec;

extern XVideoOutClassRec xVideoOutClassRec;

typedef struct
{
  Boolean	normalAspectRatio;				    /* Whether aspect ratio should be 4:3 (normal) or not */
  Window	sourceWin;					    /* Indicates the source window from which to grab image data */
  XRectangle*	sourceRect;					    /* Rectangle for digitizing video from source window */
  XRectangle*	destRect;					    /* Rectangle for output to the video display */
  int		signalStandard;					    /* Which video standard to be used: NTSC, PAL, SECAM */
  int		signalFormat;					    /* Format of the video input: RGB, SVHS, etc. */
  int		hardwareType;					    /* Indicates board being used by the computer */
  int		channel;					    /* Indicates channel on which to look for video signal */
  int		signalWidth;					    /* Read-only resources: width and height of the signal... */
  int		signalHeight;					    /* ...that can be produced by the current signalStandard. */
  Boolean	diagnostics;					    /* Whether to print widget diagnostics */
  
  plx_IO*	hardwareParams;					    /* Private variables */
  GC		gc;						    /* Needed by XPlx extension library functions */
  XRectangle	defaultSourceRect;
  XRectangle	defaultDestRect;
  int		signalBlankInterval;				    /* Height of the blanking interval for the signal produced */
  Window	outputWindow;					    /* Dummy window to use for protocol requests */
} XVideoOutPart;

typedef struct _XVideoOutRec
{
  CorePart	core;
  XVideoOutPart	xVideoOut;
} XVideoOutRec;

#endif /* _XVideoOutP_h */
