#ifndef Xvddx_h_INCLUDED
#define Xvddx_h_INCLUDED
/*
** File:
**
**   Xvddx.h --- Client accessable structures and definitions associated
**               with Xv video extension device-dependent layer.
**
** Author:
** 
**   Andy Goodrich (Parallax)
**
** Revisions:
**
**   22.01.94 Goodrich
**     - original coding
**
*/

/*  XV PORT ENCODING SPECIFICATIONS:
 *
 *  For the comments below assume a byte ordering where byte 0 is
 *  the most significant byte and byte 3 is the least significant.
 *
 */
enum { /*                vv           Miscellaneous information (byte 0) : */
	XV_GRAY_SCALE =    0x01000000,
};

enum { /*                  vv         Source timing (byte 1):  */
	XV_NTSC =          0x00010000,
	XV_PAL  =          0x00020000,
	XV_SECAM =         0x00030000,
	XV_SOURCE_TIMING = 0x00FF0000,
};

enum { /*                    vv       Source type (byte 2):  */
	XV_COMPOSITE =     0x00000100,
    XV_RGB =           0x00000200,
	XV_YC =            0x00000300,
	XV_YUV =           0x00000400,
	XV_SOURCE_TYPE =   0x0000FF00,
};

enum { /*                      vv     Source number by type (0..n) (byte 3): */
	XV_SOURCE_NUMBER = 0x000000FF,
	XV_SOURCE_CONNECTION = (XV_SOURCE_TYPE | XV_SOURCE_NUMBER),
};


/* VALUES FOR XV_STATUS PORT ATTRIBUTE:
 */
enum {              
    XVS_Attached = 1,   /* Port is attached to a drawable. */
	XVS_Sync = 2,       /* Port's input has an active sync. */
};

#endif /* Xvddx_h_INCLUDED */
