/* $Header: /plx/S/source/Xclients/solaris2.4/3.4.new/RCS/PortableAudio.h,v 0.93 1994/06/15 03:26:10 drapeau Exp $ */
/*
 *   Copyright (c) 1993 by
 *   PARALLAX GRAPHICS, INCORPORATED, Santa Clara, California.
 *   All rights reserved
 *
 *   This software is furnished on an as-is basis, and may be used and copied
 *   only with the inclusion of the above copyright notice.
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 *   Author: George Drapeau
 */
/* $Log: PortableAudio.h,v $
 * Revision 0.93  1994/06/15  03:26:10  drapeau
 * Added Sun-specific defined constants to enhance portability with older
 * programs that generate and read JPEG Movie files.
 *
 * Revision 0.92  1994/05/31  19:58:16  drapeau
 * Added new defined constants for the type of encoding used to digitize
 * audio.
 *
 * Revision 0.91  1994/01/20  22:52:26  drapeau
 * Added a couple of defined constants and a prototype to support
 * recording options.
 *
 * Revision 0.90  1994/01/20  18:02:24  drapeau
 * First working version.
 * */
#ifndef _PortableAudioHeader_
#define _PortableAudioHeader_
static char portableAudioHeaderRcsId[] = "$Header: /plx/S/source/Xclients/solaris2.4/3.4.new/RCS/PortableAudio.h,v 0.93 1994/06/15 03:26:10 drapeau Exp $";

#ifdef __hpux
#include <sys/audio.h>
#include "hpAudio.h"
#else
  #include <multimedia/libaudio.h>
  #include <multimedia/audio_device.h>
  #ifdef SVR4
    #include <multimedia/audio_encode.h>
  #else
    #include <multimedia/ulaw2linear.h>
  #endif
#endif

/* Here are some Sun-specific audio encoding defined constants. */
/* They are used for now in order to preserve compatibility... */
/* ...older versions of JPEG Movie recorders/players. */
/* This really should be eliminated and a cross-platform... */
/* ...audio standard should be defined once and for all. */

#ifndef AUDIO_ENCODING_ULAW
#define	AUDIO_ENCODING_ULAW	(1)	/* u-law encoding */
#endif
#ifndef AUDIO_ENCODING_ALAW
#define	AUDIO_ENCODING_ALAW	(2)	/* A-law encoding */
#endif
#ifndef AUDIO_ENCODING_LINEAR
#define	AUDIO_ENCODING_LINEAR	(3)	/* Linear PCM encoding */
#endif

#define AudioSpeaker	0
#define AudioHeadphone	1
#define AudioMicrophone 2
#define AudioLineIn	3
#define AudioLineOut	4

#define AudioULawEncoding	1
#define AudioALawEncoding	2
#define AudioLinearEncoding	3

typedef struct _PortableAudioPlayRecord
{
  int	sampleRate;
  int	channels;
  int	bitsPerSample;
  int	encoding;
  int	volume;
} PortableAudioPlayRecord;

typedef struct _PortableAudio
{
  PortableAudioPlayRecord	play;
  PortableAudioPlayRecord	record;
  int				monitorVolume;
} PortableAudio;


void PrintAudioInfo(int, PortableAudio*);
void SetRecordDevice(int, int);

#endif _PortableAudioHeader_
