/* $Header: /plx/S/source/Xclients/solaris2.4/3.4.new/RCS/globals.c,v 1.19 1994/09/14 03:22:50 drapeau Exp $ */
/*
 *   Copyright (c) 1993 by
 *   PARALLAX GRAPHICS, INCORPORATED, Santa Clara, California.
 *   All rights reserved
 *
 *   This software is furnished on an as-is basis, and may be used and copied
 *   only with the inclusion of the above copyright notice.
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 *   Author: George Drapeau
 */
/* $Log: globals.c,v $
 * Revision 1.19  1994/09/14  03:22:50  drapeau
 * Made the imageQualitySourceRect a global variable.
 *
 * Revision 1.18  1994/08/23  01:33:55  drapeau
 * Added code for an alert dialog box.
 *
 * Revision 1.17  1994/08/11  03:16:38  drapeau
 * Added a couple of variables for enhanced diagnostics.
 *
 * Revision 1.16  1994/05/31  20:10:59  drapeau
 * Added a number of variables to support better diagnostics and
 * automatic playback and quit for movies.  Also, changed types of some
 * variables used in synchronization code (changed from integer data
 * types to floating point data types).
 *
 * Revision 1.15  1994/01/20  22:51:57  drapeau
 * Added two variables that had previously been removed.  They were added
 * to support a slight change in the PortableAudio interface which was
 * made to accommodate the Sun audio device driver implementation, which
 * is flawed, in my opinion.
 *
 * Revision 1.14  1994/01/20  18:05:14  drapeau
 * Modified code to support the PortableAudio interface, increasing
 * portability across platforms.
 *
 * Also added new variables to support new features and removed obsolete
 * variables.
 *
 * Revision 1.13  1994/01/10  22:40:06  drapeau
 * Added support for high-quality audio and the MAEstro Multimedia
 * Authoring Environment.
 *
 * Revision 1.12  1993/12/04  01:03:22  drapeau
 * Modified the code to make the Pause feature more robust.  Before this
 * version, pausing a movie during playback would throw off the
 * synchronization mechanism; pause now works correctly.
 *
 * Revision 1.11  1993/12/03  01:35:33  drapeau
 * Added copyright message, RCS info, and a few variables for better diagnostics
 * and performance.
 * */
static char globalsRcsid[] = "$Header: /plx/S/source/Xclients/solaris2.4/3.4.new/RCS/globals.c,v 1.19 1994/09/14 03:22:50 drapeau Exp $";

#include <stdio.h>
#include <sys/param.h>
#include <sys/time.h>
#include <signal.h>
#include <fcntl.h>
#include <malloc.h>
#include <sys/ioctl.h>
#include <X11/Xlib.h>
#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#include <XPlxExt.h>
#include <XVideoIn.h>
#include <JPEG.h>
#include "PortableAudio.h"
#include <movie.h>
#include <Sender.h>
#include <Receiver.h>

Widget		imageQualityWidget;
Widget		input1Widget;
Widget		playbackWidget;
jpheader	movieHeader;
int*		frameLocation = (int*)NULL;
int*		recordFrameIndex = (int*)NULL;
float*		skippedFrameIndex = (float*)NULL;
float*		recordSkippedFrameIndex = (float*)NULL;
char*		videoFrameIndex = (char*)NULL;
long*		audioReadTime = (long*)NULL;
long*		audioWriteTime = (long*)NULL;
long*		compressTime = (long*)NULL;
long*		diskWriteTime = (long*)NULL;
long*		playInterval = (long*)NULL;
int		movieToolStatus;
XPlxCImage*	jpegImage;
XPlxCImage*	imageQualityImage;
char*		jpegData;
FILE*		movieFile;
int		currentFrame;
XtWorkProcId	playbackWorkProcID;
char*		audioData;
int		signalFrameRate;
int		outputFile;
int		audioBytesPerFrame;
int		audioControlFD;
int		recordAudioFlag;
int		audioBandwidth;
PortableAudio	audioInfo;
jpheader	recordHeader;
XtWorkProcId	recordWorkProcID;
char		outputFileName[MAXPATHLEN];
char*		currentMovieFileName;
char		titleString[MAXPATHLEN + 64];
int		totalBytesInRecording;
XRectangle	recordSourceRect;
Boolean		resetPlaybackClock;
struct timeval	playbackStartTime;
struct timeval	recordStartTime;
int		playbackStartFrame;
int		playbackEndFrame;
int		framesSkippedDuringPlayback;
int		framesSkippedDuringRecording;
int		recordFrameRate;
long		totalTimePaused;
Boolean		printDiagnostics;
int		audioDelayInFrames;
int		firstFrame;
int		lastFrame;
char		diagString[MAXPATHLEN + 64];
Sender*		sender;
Receiver*	receiver;
XtInputId	maestroFD;
int		movieStatus;
Audio_hdr	audioPlayHeader;
Audio_hdr	audioRecordHeader;
Boolean		silentMovie;
int		sampleRate;
int		numAudioChannels;
int		playbackSpeed;
Boolean		usingSharedMemory;
int		audioFD;
int		audioPlayFD;
int		audioRecordFD;
char*		fileFormat;
Boolean		monitorStatus;
int		lastMonitorVolume;
Boolean		userTurnedOffMonitor;
Boolean		autoPlay;
Boolean		autoQuit;
Boolean		startupMovie;
Boolean		autoRepeat;
char*		startupMovieName;
char*		timecodeString;
char*		errorMessage;
XRectangle	imageQualitySourceRect;
