/* $Header: /plx/S/source/Xclients/solaris2.4/3.4.new/RCS/sunSpecific.c,v 0.91 1994/09/13 08:10:41 drapeau Exp $ */
/*
 *   Copyright (c) 1994 by
 *   PARALLAX GRAPHICS, INCORPORATED, Santa Clara, California.
 *   All rights reserved
 *
 *   This software is furnished on an as-is basis, and may be used and copied
 *   only with the inclusion of the above copyright notice.
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 *   Author: George Drapeau
 */
/* $Log: sunSpecific.c,v $
 * Revision 0.91  1994/09/13  08:10:41  drapeau
 * Removed extraneous variables.
 *
 * Revision 0.90  1994/08/27  05:49:38  drapeau
 * First working version.
 * */
static char sunSpecificRcsid[] = "$Header: /plx/S/source/Xclients/solaris2.4/3.4.new/RCS/sunSpecific.c,v 0.91 1994/09/13 08:10:41 drapeau Exp $";


#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#include <Xm/Xm.h>
#include <Xm/PushB.h>
#include <Xm/Scale.h>
#include <Xm/PushBG.h>
#include "MovieTool.h"



void SaveMPEGFile(char* fileName)
{
  sprintf(errorMessage,
	  "Saving MPEG files is not yet implemented on this platform.\n");
  PrintErrorMessage(errorMessage);
  return;
} /* end function SaveMPEGFile */



void ShowCompactMovieDialog(Widget	w,
			    XtPointer	client_data,
			    XtPointer	xt_call_data)
{
  XtVaSetValues(fileDialog,
		XmNtitle, "Compact This Movie",
		NULL);
  XtRemoveCallback(fileSelectionBox, XmNokCallback, SaveMovie, NULL);
  XtRemoveCallback(fileSelectionBox, XmNokCallback, OpenMovie, NULL);
  XtRemoveCallback(fileSelectionBox, XmNokCallback, CompactMovie, NULL);
  XtAddCallback(fileSelectionBox, XmNokCallback, CompactMovie, NULL);
  XtVaSetValues(saveAsOptionButton, XmNsensitive, False, NULL);	    /* Don't allow author to choose final movie output format */
  XtManageChild(fileSelectionBox);
  return;
} /* end function ShowCompactMovieDialog */



void ShowInput1(Widget		w,
		XtPointer	client_data,
		XtPointer	xt_call_data )
{
  Dimension		signalWidth;
  Dimension		signalHeight;
  int			signalStandard;
  XmPushButtonCallbackStruct*	callData =
    (XmPushButtonCallbackStruct *) xt_call_data;
  
  XtPopup(input1Shell, XtGrabNone);
  XtVaSetValues(input1Widget, XtNchannel, PLX_IO_OFF, NULL);
  XtVaSetValues(input1Widget, XtNchannel, PLX_INPUT_0, NULL);
  XtVaGetValues(input1Widget,					    /* Determine the signal standard for this video input, so... */
		XtNsignalStandard, &signalStandard,		    /* ...the frame rate for this standard can be determined. */
		XtNsignalWidth, &signalWidth,
		XtNsignalHeight, &signalHeight,
		NULL);
/*
  XtVaSetValues(input1Widget,
		XtNwidth, (signalWidth / 2),
		XtNheight, (signalHeight / 2),
		NULL);
*/
  if (signalStandard == PLX_NTSC)				    /* Is it an NTSC signal? */
  {
    signalFrameRate = 30;					    /* Yep, frame rate is 30 Hz */
    XtVaSetValues(recordSpeedSlider, XmNvalue, 30, NULL);
  }
  else								    /* Nope, must be PAL or SECAM; frame rate is 25 Hz */
  {
    signalFrameRate = 25;
    XtVaSetValues(recordSpeedSlider, XmNvalue, 25, NULL);
  }
  return;
} /* end function ShowInput1 */



void ShowInput2(Widget		w,
		XtPointer	client_data,
		XtPointer	xt_call_data )
{
  Dimension		signalWidth;
  Dimension		signalHeight;
  int			signalStandard;
  
  XtPopup(input1Shell, XtGrabNone);
  XtVaSetValues(input1Widget, XtNchannel, PLX_IO_OFF, NULL);
  XtVaSetValues(input1Widget, XtNchannel, PLX_INPUT_1, NULL);
  XtVaGetValues(input1Widget,					    /* Determine the signal standard for this video input, so... */
		XtNsignalStandard, &signalStandard,		    /* ...the frame rate for this standard can be determined. */
		XtNsignalWidth, &signalWidth,
		XtNsignalHeight, &signalHeight,
		NULL);
/*
  XtVaSetValues(input1Widget,
		XtNwidth, (signalWidth / 2),
		XtNheight, (signalHeight / 2),
		NULL);
*/
  if (signalStandard == PLX_NTSC)				    /* Is it an NTSC signal? */
  {
    signalFrameRate = 30;					    /* Yep, frame rate is 30 Hz */
    XtVaSetValues(recordSpeedSlider, XmNvalue, 30, NULL);
  }
  else								    /* Nope, must be PAL or SECAM; frame rate is 25 Hz */
  {
    signalFrameRate = 25;
    XtVaSetValues(recordSpeedSlider, XmNvalue, 25, NULL);
  }
  return;
}
