/* $Header: /plx/S/source/Xclients/solaris2.4/3.4.new/RCS/VideoTool.h,v 1.15 1994/09/14 05:58:34 drapeau Exp $ */
/*
 *   Copyright (c) 1994 by
 *   PARALLAX GRAPHICS, INCORPORATED, Santa Clara, California.
 *   All rights reserved
 *
 *   This software is furnished on an as-is basis, and may be used and copied
 *   only with the inclusion of the above copyright notice.
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 *   Author: George Drapeau
 */
/* $Log: VideoTool.h,v $
 * Revision 1.15  1994/09/14  05:58:34  drapeau
 * Significant changes to the implementation of the rubberband code.  It
 * works cleanly now.
 *
 * Revision 1.14  1994/09/13  08:04:04  drapeau
 * Added function prototypes to accommodate new functionality.
 *
 * Revision 1.13  1994/09/04  07:12:59  drapeau
 * Added support for correctly handling deletion of video input shells
 * via the XmProtocols mechanism.  Also added the "autoSearch" variable,
 * which is set on a platform-specific basis (autoSearch is turned off
 * for HP and on for Sun).
 *
 * Revision 1.12  1994/08/27  05:51:11  drapeau
 * Minor changes to add global variable declarations and function
 * prototypes.
 *
 * Revision 1.11  1994/08/14  01:43:32  drapeau
 * Added a function prototype for os-specific initialization code.
 *
 * Revision 1.1  1994/03/22  04:51:20  drapeau
 * Initial revision
 * */
#ifndef _VideoToolHeader_
#define _VideoToolHeader_
static char videoToolHeaderRcsId[] = "$Header: /plx/S/source/Xclients/solaris2.4/3.4.new/RCS/VideoTool.h,v 1.15 1994/09/14 05:58:34 drapeau Exp $";
#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#include <Xm/Xm.h>
#include <Xm/CascadeB.h>
#include <Xm/DialogS.h>
#include <Xm/FileSB.h>
#include <Xm/Form.h>
#include <Xm/Frame.h>
#include <Xm/Label.h>
#include <Xm/List.h>
#include <Xm/MessageB.h>
#include <Xm/PushB.h>
#include <Xm/RowColumn.h>
#include <Xm/Scale.h>
#include <Xm/ScrollBar.h>
#include <Xm/SelectioB.h>
#include <Xm/TextF.h>
#include <Xm/ToggleB.h>
#include <Xm/CascadeBG.h>
#include <Xm/LabelG.h>
#include <Xm/PushBG.h>
#include <Xm/SeparatoG.h>
#include <Xm/ToggleBG.h>
#include <stdio.h>
#include <XPlxExt.h>
#include <XVideoIn.h>
#include <XVideoOut.h>
#include <JPEG.h>
#include "RootWindow.h"
#include <X11/cursorfont.h>
#include "externs.h"
#include <stdlib.h>
#include <Xm/Protocols.h>

extern XtAppContext	app_context;
extern Widget 		selectedVideoWidget;
extern Widget 		input1Widget;
extern Widget 		input2Widget;
extern Widget 		outputWidget;
extern Widget 		jpegWidget;
extern Widget		selectedSettingsWidget;
extern Widget 		rootWindowWidget;
extern char*		fileFormat;
extern XRectangle	outputSourceRect;     
extern Cursor		handCursor;
extern GC		rubberBandGC;
extern int		rubberBandMode;
extern char*		errorMessage;
extern Boolean		autoSearch;
extern Atom		deleteWindowAtom;

void SelectVideoWidget(Widget);
void MoveResize(Widget, XtPointer, XEvent*, Boolean*);
void StartRubberBandAction(Widget, XtPointer, XEvent*, Boolean*);
void EndRubberBandAction(Widget, XtPointer, XEvent*, Boolean*);
void ResizeVideoOutputWidget(Widget, XtPointer, XEvent*, Boolean*);
void OsSpecificInit(void);
void WMDeleteWindowCallback(Widget, XtPointer, XtPointer);
void ResizeVideoWidgetIfNecessary(Widget widget);

#define ResizeMode	0
#define MoveMode	1
#define FILLER				 48
#define LOAD_JPEG			236
#define END_FRAME			237
#define JPEG_VERSION_1		  	1
#define JPEG_VERSION_2		  	2


typedef struct {
	char magic[8];			/* defined as "j_movie"						*/
	int version;			/* Version number							*/
	int fps;				/* frames per second						*/
	int frames;				/* Number of frames in the sequence			*/
	int width;				/* Width of each frame 						*/
	int height;				/* Height of each frame 					*/
	int bandwidth;			/* Bandwidth required for playback			*/
	int qfactor;			/* Quanization factor used in compression	*/
	int mapsize;			/* Number of colors used in colormap		*/
	int indexbuf;			/* Offset in file of frame indexes			*/
	int tracks;				/* Number of audio tracks used				*/
	int volbase;			/* Baseline for volume control				*/
	int audioslice;			/* Number of audio bytes per frame			*/
	char unusedAudioField[24];				    /* Sun-specific audio field not used by this app. */
	char filler[FILLER];	/* Pad out this record to 128 bytes			*/
} jpheader;



#endif /* _VideoToolHeader_ */
