/*
 *   Copyright (c) 1993 by
 *   PARALLAX GRAPHICS, INCORPORATED, Santa Clara, California.
 *   All rights reserved
 *
 *   This software is furnished on an as-is basis, and may be used and copied
 *   only with the inclusion of the above copyright notice.
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 *   Author: George Drapeau
 */
/* The purpose of this program is to show how to create a widget for producing
 * video output from your workstation display (that is, taking a portion of the
 * display and producing a video signal that can be viewed on a TV monitor,
 * VCR, or other such device).
 * The program creates a top-level shell and a VideoOut widget.  A rectangle
 * is used for hard-coding the area of the screen to be captured.
 */
/* $Header: /plx/S/source/Xclients/solaris2.4/3.4.new/RCS/xvOutTest.c,v 1.10 1993/09/10 12:37:39 drapeau Exp $ */
/* $Log: xvOutTest.c,v $
 * Revision 1.10  1993/09/10  12:37:39  drapeau
 * First public version of this test program.
 * */
static char xvOutTestRcsId[] = "$Header: /plx/S/source/Xclients/solaris2.4/3.4.new/RCS/xvOutTest.c,v 1.10 1993/09/10 12:37:39 drapeau Exp $";

#include <X11/Xlib.h>
#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#include <XPlxExt.h>
#include <XVideoOut.h>

static XrmOptionDescRec options[] = {
	{"-normalAspectRatio",	"*videoOut.normalAspectRatio",		XrmoptionSepArg,	NULL, },
	{"-channel",		"*videoOut.channel",			XrmoptionSepArg,	NULL, },
};

Widget top, videoWidget;

void main(int argc, char** argv)
{
  XRectangle	theRect;
  
  theRect.x = 0;
  theRect.y = 0;
  theRect.width = 320;
  theRect.height = 240;
  top = XtInitialize("xvideoOut", "XVideoOut",
		     options, XtNumber(options), &argc, argv);
  videoWidget = XtVaCreateManagedWidget ("videoOut",
					 xVideoOutWidgetClass,
					 top,
					 XtNsourceRect, &theRect,
					 NULL);
  XtRealizeWidget(top);
  XtMainLoop();
}
