/*
 *   Copyright (c) 1990 by
 *   PARALLAX GRAPHICS, INCORPORATED, Santa Clara, California.
 *   All rights reserved
 *
 *   This software is furnished on an as-is basis, and may be used and copied
 *   only with the inclusion of the above copyright notice.
 *
 *   The information in this software is subject to change without notice.
 *   No committment is made as to the usability or reliability of this
 *   software.
 *
 *   Parallax Graphics, Inc.
 *   2500 Condensa Street
 *   Santa Clara, California  95051
 *   Author: Murali. V. Srinivasan
 */

#ifndef lint
static char *sid_xvideo_c = "@(#)xvideo.c	1.14 9/7/90 	Parallax Graphics Inc";
#endif

#include <stdio.h>
#include <sys/param.h>
#include <signal.h>
#ifdef SYSTYPES
#include <sys/types.h>
#endif
#include <X11/Xlib.h>
#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xol/OpenLook.h>
#include <Xol/Button.h>
#include <Xol/Caption.h>
#include <Xol/Exclusives.h>
#include <Xol/Menu.h>
#include <Xol/MenuButton.h>
#include <Xol/OblongButt.h>
#include <Xol/OlClients.h>
#include <Xol/ControlAre.h>
#include <Xol/FooterPane.h>
#include <Xol/PopupWindo.h>
#include <Xol/RectButton.h> 
#include <Xol/StaticText.h>
#include <Xol/TextField.h>
#include <Xol/Form.h>
	
#include <XPlxExt.h>
#include <XVideo.h>

#define NCASES 5
#define NCOLORS 16

extern void exit();

int plxdebugflag = 0;
static int video_channel_previous=0;
static int video_channel=0;

Boolean live = 1;
static int nn[NCASES];

TextFieldWidget textw1;
CaptionWidget   caption1;
static void    VerifyCallback1();

static void First_Init();
static void Set_Color();
static void Quit();
static void GetColors();
static void Draw_Box();
static void Draw_Line();
static void Draw_Text();
static void Wipe_Side();
static void Wipe_Down();
static void Fade_In();
static void Checkers();
static void Fade_Out();
static void Funnel();
static void Slider();
static void Clear_Screen();
static void Pixelize();
static void setupcolormap();
#ifdef SVR4
static void MyUSleep(unsigned int);
#else
static void MyUSleep();
#endif

static XColor   this_red, exact_red, this_blue, exact_blue,
                this_green, exact_green,this_black, exact_black;

static XWindowAttributes win_atts;

static int x=50;
static int y=50;
static int x1=50;
static int y1=50;
static int x2=350;
static int y2=350;
static int x3=50;
static int y3=100;
static int first=1;
static int first_time = 1;
static int delay_value = 50;
 
enum footer_type {
                                NONE, TEXT, STEXT, TFIELD
                                } f_type;

static Cardinal n;
int nchannels;
static XrmOptionDescRec options[] = {
	{"-live",	"*video.live",	XrmoptionNoArg,	"TRUE", },
	{"-still",	"*video.live",	XrmoptionNoArg,	"FALSE", },
};

Widget 		top, video_widget,video_widget1;
Widget          control, form, box, line, text,menupane,menupane1,popupshell,popupbutton,popupca1,popupca2,mexclusives;
Widget 		panex,menubutton,menubutton1,generic_widget,genvid,clear,quit;

Position vidx, vidy;

static XtCallbackRec callback[2];
static Arg args[25];

Dimension videowidth = 640;
Dimension videoheight = 480;

static int inited = 0;
Display *disp;
Window win;
GC gc,gc0,gc1;
XGCValues       values;

XVisualInfo vinfo, *vinfos;
Visual *visual = NULL;
int j;
int screen;

static void popupCB1(w,clientData,callData)
        Widget w;
        XtPointer clientData, callData;
{
        XtPopup(clientData,XtGrabNone);
}

static void VerifyCallback1(widget, clientData, callData)
TextFieldWidget widget;
caddr_t clientData, callData;
{
        int     i;
        Arg     args[10];
        char    *string;

        i = 0;
        XtSetArg(args[i],XtNstring, &string);   i++;
        XtGetValues(widget, args, i);

	delay_value = atoi(string);

        i = 0;
        XtSetArg(args[i],XtNstring, string);    i++;
        XtSetValues(textw1, args, i);
}



void main(argc, argv)
int argc;
char **argv;
{
	XtWidgetGeometry geom_p, geom_i;
	register int scr;
	plx_IO_list *inputp;
        XFontStruct *font_info;
	char *fontname = "12x24";
	int i;
	
	top = OlInitialize("xvideo", "XVideo", options, XtNumber(options), &argc, argv);

        n = 0;
        XtSetArg(args[n], XtNborderWidth, 0); n++;
 
        form = XtCreateManagedWidget("form", formWidgetClass,
                        top, args, n);
 
	n = 0;
        XtSetArg(args[n], XtNcenter, TRUE); n++;
        XtSetArg(args[n], XtNlayoutType, OL_FIXEDROWS); n++;
        XtSetArg(args[n], XtNsameSize, OL_NONE); n++;
	XtSetArg(args[n], XtNx,0); n++;
	XtSetArg(args[n], XtNy,videoheight + 1); n++; 
        control = XtCreateManagedWidget("control", controlAreaWidgetClass,
                        form, args, n);

	n = 0;
        line = XtCreateManagedWidget("Draw Line", oblongButtonWidgetClass,
                        control, args, n);
        XtAddCallback(line,XtNselect,Draw_Line,NULL);

        n=0;
        box = XtCreateManagedWidget("Draw Box", oblongButtonWidgetClass,
                        control, args, n);
        XtAddCallback(box,XtNselect,Draw_Box,NULL);


	n = 0;
        text = XtCreateManagedWidget("Draw Text", oblongButtonWidgetClass,
                        control, args, n);
        XtAddCallback(text,XtNselect,Draw_Text,NULL);
 

	popupbutton = XtCreateManagedWidget("Special F/X",
                oblongButtonWidgetClass,control,NULL,0);
 
        i = 0;
        popupshell = XtCreatePopupShell("SPECIAL F/X",
                popupWindowShellWidgetClass,popupbutton,args,i);

/*
   Add callback to popup button now that we have popupshell widget ID.
*/
        XtAddCallback(popupbutton, XtNselect, popupCB1, popupshell);
/*
 The popup window automatically makes three children: upper and
 lower control areas and footer: get widget IDs to populate them.
*/
        i = 0;
        XtSetArg(args[i], XtNupperControlArea, &popupca1); i++;
        XtSetArg(args[i], XtNlowerControlArea, &popupca2); i++;
        XtGetValues (popupshell, args, i);
 
/*
  Populate popup upper control area.
*/
        XtSetArg(args[0],XtNlayoutType,OL_FIXEDCOLS);
        XtSetValues(popupca1,args,1);
 
        i = 0;
        XtSetArg(args[i],XtNlayoutType,(XtArgVal) OL_FIXEDCOLS); i++;
        XtSetArg(args[i],XtNmeasure,(XtArgVal) 1); i++;

        panex = XtCreateManagedWidget("exclusives",
                        exclusivesWidgetClass,popupca1,args,i);


	n = 0;
        XtSetArg(args[n],XtNlabelJustify,OL_LEFT); n++;

        generic_widget = XtCreateManagedWidget("Clear Screen",
                rectButtonWidgetClass,panex,args,n);
        XtAddCallback(generic_widget,XtNselect,Clear_Screen,1);

	n = 0;
        XtSetArg(args[n],XtNlabelJustify,OL_LEFT); n++;
        generic_widget = XtCreateManagedWidget("Wipe Down",
                rectButtonWidgetClass,panex,args,n);
        XtAddCallback(generic_widget,XtNselect,Wipe_Down,2);

	n = 0;
        XtSetArg(args[n],XtNlabelJustify,OL_LEFT); n++;
        generic_widget = XtCreateManagedWidget("Wipe Side",
                rectButtonWidgetClass,panex,args,n);
        XtAddCallback(generic_widget,XtNselect,Wipe_Side,3);

	n = 0;
        XtSetArg(args[n],XtNlabelJustify,OL_LEFT); n++;
        generic_widget = XtCreateManagedWidget("Barn Doors In",
                rectButtonWidgetClass,panex,args,n);
        XtAddCallback(generic_widget,XtNselect,Fade_In,4);

	n = 0;
        XtSetArg(args[n],XtNlabelJustify,OL_LEFT); n++;
        generic_widget = XtCreateManagedWidget("Barn Doors Out",
                rectButtonWidgetClass,panex,args,n);
        XtAddCallback(generic_widget,XtNselect,Fade_Out,5);

	n = 0;
        XtSetArg(args[n],XtNlabelJustify,OL_LEFT); n++;
        generic_widget = XtCreateManagedWidget("Checkers ",
                rectButtonWidgetClass,panex,args,n);
        XtAddCallback(generic_widget,XtNselect,Checkers,6);

	n = 0;
        XtSetArg(args[n],XtNlabelJustify,OL_LEFT); n++;
        generic_widget = XtCreateManagedWidget("Slider ",
                rectButtonWidgetClass,panex,args,n);
        XtAddCallback(generic_widget,XtNselect,Slider,7);

/*
        n = 0;
        XtSetArg(args[n],XtNlabelJustify,OL_LEFT); n++;
        generic_widget = XtCreateManagedWidget("Pixelize ",
                rectButtonWidgetClass,panex,args,n);
        XtAddCallback(generic_widget,XtNselect,Pixelize,8);
*/

        n = 0;
        XtSetArg(args[n], XtNlabel,"Delay (us):"); n++;
        caption1 = (CaptionWidget) XtCreateManagedWidget("caption1",
                                                captionWidgetClass,
                                                popupca2,
                                                args,
                                                n);  
        n = 0;
        XtSetArg(args[n], XtNmaximumSize, 6);n++;
        XtSetArg(args[n], XtNstring, "50");n++;
 
        textw1 = (TextFieldWidget) XtCreateManagedWidget(       "text1",
                                        textFieldWidgetClass,
                                        caption1,
                                        args,
                                        n);  
        XtAddCallback(textw1, XtNverification, VerifyCallback1, NULL);

        n = 0;
        XtSetArg(args[n],XtNpushpin,(XtArgVal) OL_OUT); n++;
        XtSetArg(args[n],XtNlabelType,(XtArgVal) OL_STRING); n++;
        XtSetArg(args[n],XtNlabelJustify,(XtArgVal) OL_LEFT); n++;
        XtSetArg(args[n],XtNrecomputeSize,(XtArgVal) TRUE); n++;

        menubutton = XtCreateManagedWidget("Drawing Color", menuButtonWidgetClass
				           ,control, args, n);
/*
Get the Widget id of the menupane of the menubutton.
*/
        i = 0;
        XtSetArg(args[i], XtNmenuPane,(XtArgVal) &menupane); i++;
        XtGetValues(menubutton, args, i);
 
/*
Make the exclusives widget for the menupane, column format.
*/
        i = 0;
        XtSetArg(args[i],XtNlayoutType,(XtArgVal) OL_FIXEDCOLS); i++;
        XtSetArg(args[i],XtNmeasure,(XtArgVal) 1); i++;
 
        mexclusives = XtCreateManagedWidget("exclusives",
                        exclusivesWidgetClass,menupane,args,i);
                         
        generic_widget = XtCreateManagedWidget("RED",
                rectButtonWidgetClass,mexclusives,NULL,0);
	XtAddCallback(generic_widget,XtNselect,Set_Color,1);
 
       generic_widget = XtCreateManagedWidget("GREEN",
                rectButtonWidgetClass,mexclusives,NULL,0);
        XtAddCallback(generic_widget,XtNselect,Set_Color,2); 

       generic_widget = XtCreateManagedWidget("BLUE",
                rectButtonWidgetClass,mexclusives,NULL,0);
        XtAddCallback(generic_widget,XtNselect,Set_Color,3);

       genvid = XtCreateManagedWidget("VIDEO IN 1",
                rectButtonWidgetClass,mexclusives,NULL,0);
	XtAddCallback(genvid,XtNselect,Set_Color,4);

       genvid = XtCreateManagedWidget("VIDEO IN 2",
                rectButtonWidgetClass,mexclusives,NULL,0);
        XtAddCallback(genvid,XtNselect,Set_Color,5);

	n = 0;
        quit = XtCreateManagedWidget("quit", oblongButtonWidgetClass,
                        control, args, n);

        XtAddCallback(quit, XtNselect, Quit, NULL);

        n = 0;
        XtSetArg(args[n], XtNborderWidth, 0); n++;
	XtSetArg(args[n], XtNresizeParent,TRUE) ;n++;
        XtSetArg(args[n], XtNconfigWidget, top); n++;
	XtSetArg(args[n], XtNgravity, CenterGravity); n++;
	XtSetArg(args[n], XtNchannel,PLX_INPUT_0); n++;
	
        video_widget = XtCreateManagedWidget ("video", videoWidgetClass,
                                               form,args,n);
 
        XtRealizeWidget(top);

        disp =XtDisplay(video_widget);
        win = XtWindow(video_widget);

	i = 0;
        XtSetArg(args[i], XtNgc,(XtArgVal)&gc0); i++;
        XtGetValues(video_widget, args, i);

        gc1 = XCreateGC(disp, win, 0, 0);

	XGetWindowAttributes(disp,win,&win_atts);

        GetColors(XtDisplay(video_widget));

	values.foreground = this_red.pixel;
        values.background = this_black.pixel;
	values.plane_mask = 0;

        XChangeGC(disp,gc0,GCForeground|GCBackground|GCPlaneMask,&values); 
        XChangeGC(disp,gc1,GCForeground|GCBackground|GCPlaneMask,&values);

        if ((font_info = XLoadQueryFont(disp,fontname)) == NULL) 
        { 
                (void) fprintf( stderr, "Basic: Cannot open font\n"); 
                exit( -1 ); 
        } 
	

        XSetFont(disp, gc0, font_info->fid);
        XSetFont(disp, gc1, font_info->fid);
	gc = gc0;
        XtMainLoop();
}

static void

Quit(w, closure, call_data)
        Widget w;
        caddr_t closure, call_data;
{
        fprintf(stderr, "bye \n");
        exit(0);
}

static void set_channel()
{
int i;   
        if (video_channel != video_channel_previous)
        {       
        video_channel_previous = video_channel;
        if (video_channel == 0)
        {
                i = 0;
                XtSetArg(args[i], XtNchannel,PLX_INPUT_0); i++;
                XtSetArg(args[i], XtNgc, gc); i++;
                XtSetArg(args[i], XtNredisplay, FALSE); i++;
		XtSetArg(args[i], XtNnewframe, FALSE); i ++;
                XtSetValues(video_widget, args, i);
        }
        else
        {
                i = 0;
                XtSetArg(args[i], XtNchannel,PLX_INPUT_1); i++;
                XtSetArg(args[i], XtNgc, gc); i++;
                XtSetArg(args[i], XtNredisplay, FALSE); i++;
		XtSetArg(args[i], XtNnewframe, FALSE); i ++;
                XtSetValues(video_widget, args, i);
        }
        }
}


static void
Set_Color(widget,clientData,callData)
	Widget widget;
	caddr_t clientData, callData;
{
	int i = (int) clientData;

        switch(i) {
                case 1:
		if (first) first = 0;
		if ( video_channel == 0 )
		   gc = gc0;
		else
		   gc = gc1;
		values.foreground = this_red.pixel;
                values.plane_mask = -1;  
                XChangeGC(disp,gc,GCForeground|GCBackground|GCPlaneMask,&values); 
		XPlxVideoTag(disp,win,gc,PLX_GRAPHICS_8);
                break; 
                case 2:
		if (first) first = 0;
                if ( video_channel == 0 ) 
                   gc = gc0; 
                else 
                   gc = gc1; 
        	values.foreground = this_green.pixel;
                values.plane_mask = -1;   
        	XChangeGC(disp,gc,GCForeground|GCBackground|GCPlaneMask,&values);
                XPlxVideoTag(disp,win,gc,PLX_GRAPHICS_8); 
                break; 
                case 3:
		if (first) first = 0;
                if ( video_channel == 0 ) 
                   gc = gc0; 
                else 
                   gc = gc1; 
        	values.foreground = this_blue.pixel;
                values.plane_mask = -1;   
                XChangeGC(disp,gc,GCForeground|GCBackground|GCPlaneMask,&values); 
                XPlxVideoTag(disp,win,gc,PLX_GRAPHICS_8); 
                break;
                case 4:
		if (first) first = 0;
		video_channel = 0;
		gc = gc0;
                values.plane_mask = -1;   
                XChangeGC(disp,gc,GCForeground|GCBackground|GCPlaneMask,&values); 
		XPlxVideoTag(disp,win,gc,PLX_VIDEO);	
		set_channel();	
                break;
		case 5:
		if (first) first = 0;
		gc = gc1;
		if (first_time)
		 {
                  i = 0;
                  XtSetArg(args[i], XtNchannel,PLX_INPUT_1); i++;
                  XtSetArg(args[i], XtNgc, gc); i++;
                  XtSetArg(args[i], XtNredisplay, TRUE); i++;
                  XtSetValues(video_widget, args, i);
		  i = 0;
                  XtSetArg(args[i], XtNchannel,PLX_INPUT_0); i++;
                  XtSetArg(args[i], XtNgc, gc0); i++;
                  XtSetArg(args[i], XtNredisplay, TRUE); i++;
                  XtSetValues(video_widget, args, i);
		  first_time = 0;
		}
		video_channel = 1;
                values.plane_mask = -1;   
                XChangeGC(disp,gc,GCForeground|GCBackground|GCPlaneMask,&values); 
                XPlxVideoTag(disp,win,gc,PLX_VIDEO);
		set_channel();
                break;
		}
} 

static void GetColors(d)
Display *d;

{
 XAllocNamedColor(d,win_atts.colormap,"red", &this_red,&exact_red);
 XAllocNamedColor(d,win_atts.colormap,"blue", &this_blue, &exact_blue);
 XAllocNamedColor(d,win_atts.colormap,"green", &this_green, &exact_green);
 XAllocNamedColor(d,win_atts.colormap, "black", &this_black, &exact_black);
}

static void First_Init()
{           
            values.plane_mask = -1; 
            XChangeGC(disp,gc,GCForeground|GCBackground|GCPlaneMask,&values);
            XPlxVideoTag(disp,win,gc,PLX_GRAPHICS_8);
            first=0;
}

static void Draw_Line()
{
	if (first) First_Init();

	XDrawLine(disp,win,gc,x1,y1,x2,y2);

        x1 = x1 + 10; 
        y1 = y1 + 20; 
	x2 = x2 + 10;
	y2 = y2 + 20;
        if (x1 > videowidth ) x1 = 10; 
        if (y1 > videoheight) y1 = 10; 
        if (x2 > videowidth ) x2 = 10;
        if (y2 > videoheight) y2 = 10;
} 

static void Draw_Box()
{
       if (first) First_Init();

	XDrawRectangle(disp,win,gc,x,y,64,64);
	XFillRectangle(disp,win,gc,x,y,64,64);
	x = x + 10;
	y = y + 20;
	if ( x > videowidth ) x = 10;
	if ( y > videoheight ) y = 10;
}

static void Draw_Text()
{
       	if (first) First_Init();

	XDrawString(disp,win,gc,x3,x3,"PARALLAX GRAPHICS",strlen("PARALLAX GRAPHICS"));
		
 	x3 = x3 + 40;
	y3 = y3 + 50;
	if ( x3 > videowidth ) x3 = 10;
	if ( y3 > videoheight ) y3 = 10;
	XFlush(disp);
		
}

static void Clear_Screen()
{
       	if (first) First_Init();

	XFillRectangle(disp,win,gc,0,0,videowidth,videoheight);
}

static void Wipe_Down()
{
int i;
       if (first) First_Init();

	i = 0;
	while ( i <= videoheight)
	{
          XDrawLine(disp,win,gc,1,i,videowidth,i);
          i = i++;
	  XFlush(disp);
	  MyUSleep(delay_value);
	}
}		

static void Wipe_Side()
{
int i,j;
       if (first) First_Init();

	i = 0;
	while ( i <= videowidth)
	   {
             XDrawLine(disp,win,gc,i,1,i,videoheight);
             i = i++;
	     XFlush(disp);
	     MyUSleep(delay_value);
	   }
}

static void Fade_In()
{
int i,k;

       if (first) First_Init();

        i = 0;
	k = videowidth;
	
	while (i <= videowidth/2)
	   { 
             XDrawLine(disp,win,gc,i,1,i,videoheight);
             XDrawLine(disp,win,gc,k,1,k,videoheight);
	     XFlush(disp);
	     k = k - 1;
	     i++;
             MyUSleep(delay_value);
	  }
}

static void Fade_Out()
{
int i,start;

       	if (first) First_Init();

        start = videowidth/2;
	i = 0;
        
        while (i <= videowidth/2)
           {
              XDrawLine(disp,win,gc,start+i,1,start+i,videoheight);
              XDrawLine(disp,win,gc,start-i,1,start-i,videoheight);
              XFlush(disp);
              i++;
	      MyUSleep(delay_value);
            }
}
static void Checkers()
{
int i,j,x,y,numx,numy,xint,yint,xinter[20],yinter[20];

 
       	if (first) First_Init();

	numx = 8;
	numy = 8;
	xint = videowidth/numx;
	yint = videoheight/numy;
	j = 0;
	for(x=0; x < videowidth; x=x+xint )
	  {
	   xinter[j] = x;
	   j ++;
	  }
	j = 0;
        for(y=0; y < videoheight; y=y+yint) 
          { 
           yinter[j] = y; 
           j ++; 
          } 

	for ( y=0; y < numy; y = y + 2)
	   {
	    for (x=0;x < numx; x = x + 2)
 	     {
        	XDrawRectangle(disp,win,gc,xinter[x],yinter[y],xint,yint);
        	XFillRectangle(disp,win,gc,xinter[x],yinter[y],xint,yint);
        	XDrawRectangle(disp,win,gc,xinter[x+1],yinter[y+1],xint,yint);
        	XFillRectangle(disp,win,gc,xinter[x+1],yinter[y+1],xint,yint);
	        XFlush(disp);	
	     }
	     MyUSleep(delay_value);
	   }	
   	for ( y=0; y < numy; y = y + 2)
           {
            for (x=0; x < numx; x = x + 2)
             {
                XDrawRectangle(disp,win,gc,xinter[x+1],yinter[y],xint,yint); 
                XFillRectangle(disp,win,gc,xinter[x+1],yinter[y],xint,yint); 
                XDrawRectangle(disp,win,gc,xinter[x],yinter[y+1],xint,yint); 
                XFillRectangle(disp,win,gc,xinter[x],yinter[y+1],xint,yint); 
	        XFlush(disp);	
             }   
	     MyUSleep(delay_value);
           }     
}

static void Slider()   

{
	int numslides;
	int i,j,inter,interval[10];

       	if (first) First_Init();

	numslides = 6;
	inter = videoheight/numslides;
	j = 0;
	for (i=0; i <= videoheight; i = i + inter)
	  {
	    interval[j]= i;
	    j++;
	  }
	x = 0;
	while(x<= videowidth)
	  {
	   for(j=0; j< numslides; j = j + 2)
	    {
		XDrawLine(disp,win,gc,x,interval[j],x,interval[j] + inter);
		XDrawLine(disp,win,gc,videowidth-x,interval[j+1],videowidth-x,interval[j+1] + inter);
	        XFlush(disp);
	    }
	   x++;
	   MyUSleep(delay_value);
	  }
}
/*
static void Pixelize()
{
 int x,y,i,j,k;
 int track[640][480];

       if (first) First_Init();

        i = 0;
        j = 0;
        x = 0;
        y = 0;
	k = 0;

        srand((unsigned int)time(NULL));
        while (i <= videowidth/8)
          { 
            while(j <= videoheight/7)
                {
                  x = ((unsigned) rand() % videowidth);
                  y = ((unsigned) rand() % videoheight);
                  if (track[x-1][y-1] != 1)
                    {
                      XDrawRectangle(disp,win,gc,x-1,y-1,15,15);
                      XFillRectangle(disp,win,gc,x-1,y-1,15,15);
                      track[x-1][y-1] = 1;
                      j++;
	              k++;
		      XFlush(disp);
                    }
		}
            j = 0;
            i++;
	    if (k >= 4500) break;
          }
}           
static void Funnel()
{
int x,y,mid,k;

        if (first) First_Init();

        x = 0;
	y = 0;
	mid = videoheight/2;
	for ( y=0; y<=videowidth+videowidth/4; y = y +1)
	 {
	   k = 0;
	   for ( x=y; x >= 0; x--)
	     {
	       y1 = mid -k;
	       y2 = mid + k;
	       if ( y1 > videoheight && y2 > videoheight) y1=y2=videoheight;
               XDrawLine(disp,win,gc,x,y1,x,y2);
	       k++;
	       XFlush(disp);
	     }
        }
}
*/



static void MyUSleep(microseconds)
     unsigned int	microseconds;
{
#ifdef SVR4
  int			descriptorTableSize = 0;
  int			result;
  struct timeval	waitTime;				    /* Used to tell select() how long to wait until it returns */
  
  descriptorTableSize = sysconf(_SC_OPEN_MAX);			    /* Get size of descriptor table for later use by select() */
  waitTime.tv_sec = 0;						    /* Set up a timeval to wait for the time passed in as... */
  waitTime.tv_usec = microseconds;				    /* ...argument. */
  result = select(descriptorTableSize,				    /* Use select to sleep by not asking to be informed of... */
		      (fd_set*)0, (fd_set*)0,(fd_set*)0,	    /* ...input on any file descriptors, and filling in the... */
		      &waitTime);				    /* ...timeval for the wait period. */
  return;
#else
  usleep(microseconds);
  return;
#endif  
} /* end function MyUSleep */
