/* (c) Copyright 1991 Parallax Graphics Inc, All Rights Reserved */

/* This file is $OPENWINHOME/src/client/xview/comp_example/xvccomp.c */

static char *rcsid = "@(#)$Id: xvccomp.c,v 1.5 1995/01/23 18:41:58 lovvik Exp $ Parallax Graphics Inc";

#include <sys/param.h>
#include <X11/Xlib.h>
#include <xview/xview.h>
#include "Video.h"

static Frame frame, frame1;
static VideoIn video, video1;

static int videowidth  = 642;
static int videoheight = 482;

static Display *dpy;

static short QFactor=30;

#ifdef SVR4
static void MyUSleep(unsigned int);
#else
static void MyUSleep();
#endif

/* quit routine */
Notify_value quit(client, status)
Notify_client client;
Destroy_status status;
{
	if (status == DESTROY_CLEANUP) {
		frame=0;
		return(notify_next_destroy_func(client, status));
		}
	return(NOTIFY_DONE);
}

/* jpeg capture and display */
worker()
{
	JPEGImage *jpeg_image;
 
/* Grab next frame of video and display */
	xv_set(video, VIDEO_NEW_FRAME, TRUE);
 
/* Get a compressed image */
	jpeg_image = (JPEGImage *)xv_get(video, VIDEO_JPEG_IMAGE);
 
/* decompress the image into the destination window */
	xv_set(video1, VIDEO_JPEG_IMAGE, jpeg_image, NULL);

	XPlxDestroyCImage(jpeg_image);
	XSync(dpy, False);
}

main(argc, argv)
int argc;
char *argv[];
{
	register int n;

	xv_init(XV_INIT_ARGC_PTR_ARGV, &argc, argv, NULL);

	frame = (Frame) xv_create(NULL, FRAME,
		XV_LABEL,	"COMPRESSION",
		XV_X,		100,
		XV_Y,		100,
		NULL);

	dpy = (Display *) xv_get(frame, XV_DISPLAY);

	notify_interpose_destroy_func(frame, quit);

	video = xv_create(frame, VIDEO_IN,
		VIDEO_LIVE,	FALSE,
		VIDEO_SQUEEZE,	TRUE,
		VIDEO_Q_FACTOR,	QFactor,
		XV_VISUAL_CLASS, TrueColor,
		NULL);

	if (video == NULL) {
		fprintf(stderr,
  "%s: Can't create video canvas.  Check input connnection\n", argv[0]);
		exit(1);
		}

	frame1 = (Frame)xv_create(frame, FRAME,
		XV_LABEL,	"DECOMPRESSION",
		XV_X,		400,
		XV_Y,		400,
		NULL);

	video1 = xv_create(frame1, VIDEO_IN,
		VIDEO_LIVE,	FALSE,
		VIDEO_SQUEEZE,	TRUE,
		VIDEO_Q_FACTOR,	QFactor,
		XV_VISUAL_CLASS, TrueColor,
		NULL);
 
	if (video1 == NULL) {
		fprintf(stderr,
  "%s: Can't create video canvas.  Check input connnection\n", argv[0]);
		exit(1);
		}

	xv_set(frame, XV_SHOW, TRUE, NULL);
	xv_set(frame1, XV_SHOW, TRUE, NULL);

	notify_dispatch();

	while (frame) {
/* MUST WAIT FOR VIDEO CANVAS EXPOSURE BEFORE DISPLAYING JPEG DATA*/

		if (	xv_get(video, VIDEO_EXPOSED) &&
			xv_get(video1, VIDEO_EXPOSED))
			worker();

		MyUSleep(28000);
		notify_dispatch();
		if (QLength(dpy))
			xv_input_pending(dpy, XConnectionNumber(dpy));
		XFlush(dpy);
		}
}



static void MyUSleep(microseconds)
     unsigned int	microseconds;
{
#ifdef SVR4
  int			descriptorTableSize = 0;
  int			result;
  struct timeval	waitTime;				    /* Used to tell select() how long to wait until it returns */
  
  descriptorTableSize = sysconf(_SC_OPEN_MAX);			    /* Get size of descriptor table for later use by select() */
  waitTime.tv_sec = 0;						    /* Set up a timeval to wait for the time passed in as... */
  waitTime.tv_usec = microseconds;				    /* ...argument. */
  result = select(descriptorTableSize,				    /* Use select to sleep by not asking to be informed of... */
		      (fd_set*)0, (fd_set*)0,(fd_set*)0,	    /* ...input on any file descriptors, and filling in the... */
		      &waitTime);				    /* ...timeval for the wait period. */
  return;
#else
  usleep(microseconds);
  return;
#endif  
} /* end function MyUSleep */
