/*
 *  To compile:
 *
 *	gcc MAEtest.c -o MAEtest -I$PARALLAX_HOME/openwin/include
 *				 -L$PARALLAX_HOME/openwin/lib
 *				 -lMAEstro -lrpcsvc
 */ 

#include <stdio.h>
#include <Sender.h>
#include <Receiver.h>

static  Sender*		movieToolSender;
static  char*		currentDocument;
static  MAESelection*	currentSelection;

main(int argc, char** argv)
{
  Sender*	sender;
  Receiver*	receiver;
  Port		senderPort;
  Port		appPort;
  PortArray*	appList = (PortArray*)NULL;
  int		result = 0;
  char*		strdup(char*);

  senderPort.hostName = strdup("localhost");
  senderPort.portNumber = PortMgrPortNumber;
  sender = NewSender(&senderPort);				    /* Make a connection with the Port Manager */
  appPort.appName = "movietool";				    /* Fill in Port information for the app being requested */
  appPort.hostName = "localhost";
  result = SenderGetPortFromName(sender, &appPort, &appList);	    /* Try to get the requested application's Port information */
  if (result !=0)						    /* Did the call fail? */
  {								    /* Yes, print diagnostic information and exit this program. */
    printf("The GetPortFromName message failed for some reason.\n");
    printf("Either the application was not open, or it could not\n");
    printf("be launched, or the Port Manager did not respond.\n");
    exit(-1);
  }
  if (appList != (PortArray*)NULL)				    /* GetPortFromName message was successful */
    {
      movieToolSender = NewSender(&(appList->portArray[0]));	    /* Try to open a communcations link with MovieTool */
      if (movieToolSender == (Sender*)NULL)			    /* Did it fail? */
      {								    /* Yes, report the error and exit with an error code. */
	printf("Cannot create a connection to MovieTool.  Exiting.\n");
	exit(-1);
      }
    }
  GetJPEGMovieInfo();
  PlayJPEGMovie();
  exit(0);
}


GetJPEGMovieInfo()
{
  SenderGetCurrentDocName(movieToolSender, &currentDocument);
  SenderGetSelection(movieToolSender, &currentSelection);
}


PlayJPEGMovie()
{
  printf("About to play document ::%s::.\n", currentDocument);
  SenderOpenDocument(movieToolSender, currentDocument);
  SenderSetSelection(movieToolSender, currentSelection);
  SenderPerformSelection(movieToolSender);
}



