#include    <X11/Xlib.h>
#include    <xview/xview.h>
#include    "Video.h"
#include    "player.h"
#include    <xview/seln.h>
#include    <xview/notify.h>
#include    <xview/textsw.h>

 
#define PANEL_DATA              1001
 
#define icon_width 64
#define icon_height 64
 
static short icon_bits[] = {
#include "videoclip.icon"
};
 
static short mask_bits[] = {
#include "videoclip.mask"
};
 
#define BITS_WIDTH              32
#define BITS_HEIGHT             32
/* Define button glyphs for player control */
 
static short fastreverse_bits[] = {
#include "fastreverse.icon"
};
static short reverse_bits[] = {
#include "reverse.icon"
};
static short slowreverse_bits[] = {
#include "slowreverse.icon"
};
static short stepreverse_bits[] = {
#include "stepreverse.icon"
};
static short still_bits[] = {
#include "still.icon"
};
static short stepforward_bits[] = {
#include "stepforward.icon"
};
static short slowforward_bits[] = {
#include "slowforward.icon"
};
static short forward_bits[] = {
#include "forward.icon"
};
static short fastforward_bits[] = {
#include "fastforward.icon"
};
static short playsegment_bits[] = {
#include "playsegment.icon"
};
static Panel   VideoPanel;                      /* Panel pointer for user */
static Player *VideoPlayer;                     /* Pointer to player type */
static int  StartFrame;                         /* Starting frame to show
                                */
static int  EndFrame;                           /* Ending frame to show
                                */

static VideoIn VideoCanvas;                     /* Canvas pointer for video input                       */

Xv_Window VAAFrame;


Notify_value quit(client,status)
Notify_client client;
Destroy_status status;
{
                xv_destroy(VideoCanvas);
		exit(0);
}

static void VideoPanelEvent(item,event)
Panel_item item;
Event *event;
{
        int who;
 
        who = (int) xv_get(item,XV_KEY_DATA,PANEL_DATA);
        switch (who) {
        case 3:
                if (event_is_down(event)) {
                        PlayerSlowReverse(VideoPlayer);
                }
                else {
                        PlayerStill(VideoPlayer);
                }
                break;
        case 5:
                if (event_is_down(event)) {
                        PlayerSlowForward(VideoPlayer);
                }
                else {
                        PlayerStill(VideoPlayer);
                }
                break;
        default:
                break;
        }
        panel_default_handle_event(item,event);
}

/* Notify function for Player panel to handle all button presses */
 
static void VideoPanelProc(item, event)
Panel_item item;
Event *event;
{
        char *device;
        int speed,model;
        int who;
 
        who = (int) xv_get(item,XV_KEY_DATA,PANEL_DATA);
        
        switch (who) {
        case 1:
                PlayerFastReverse(VideoPlayer);
                break;
        case 2:
                PlayerReverse(VideoPlayer);
                break;
        case 3:
                break;
        case 4:
                PlayerStill(VideoPlayer);
                break;
        case 5:
                break;
        case 6:
                PlayerPlay(VideoPlayer);
                break;
        case 7:
                PlayerFastForward(VideoPlayer);
                break;
        case 8:
                if (EndFrame < StartFrame) {
                        EndFrame = StartFrame;
                }
                if (StartFrame == EndFrame) ShowDiscFrame(VideoPlayer,StartFrame);
                else {
                        if (event_shift_is_down(event))
                                ShowDiscSegment(VideoPlayer,StartFrame,EndFrame,TRUE);
                        else ShowDiscSegment(VideoPlayer,StartFrame,EndFrame,FALSE);
                }
                break;
        }
}


/* Create panel for controlling the video player on the screen */

static int CreatePlayerPanel()
{
        Server_image si;

        VideoPanel = xv_create(VAAFrame,PANEL,
                NULL);

        si = (Server_image) xv_create(NULL,SERVER_IMAGE,
                XV_WIDTH,                                       BITS_WIDTH,
                XV_HEIGHT,                                      BITS_HEIGHT,
                SERVER_IMAGE_BITS,                      fastreverse_bits,
                NULL);
        (void) xv_create(VideoPanel, PANEL_BUTTON,
                PANEL_EVENT_PROC,                       VideoPanelEvent,
                PANEL_NOTIFY_PROC,                      VideoPanelProc,
                PANEL_LABEL_IMAGE,                      si,
                XV_X,                                           xv_col(VideoPanel,1),
                XV_Y,                                           xv_row(VideoPanel,0),
                XV_KEY_DATA,                            PANEL_DATA,
        1,
                NULL);
        si = (Server_image) xv_create(NULL,SERVER_IMAGE,
                XV_WIDTH,                                       BITS_WIDTH,
                XV_HEIGHT,                                      BITS_HEIGHT,
                SERVER_IMAGE_BITS,                      reverse_bits,
                NULL);
        (void) xv_create(VideoPanel, PANEL_BUTTON,
                 PANEL_EVENT_PROC,                       VideoPanelEvent,
                PANEL_NOTIFY_PROC,                      VideoPanelProc,
                PANEL_LABEL_IMAGE,                      si,
                XV_X,                                           xv_col(VideoPanel,11),
                XV_Y,                                           xv_row(VideoPanel,0),
                XV_KEY_DATA,                            PANEL_DATA,
        2,
                NULL);
        si = (Server_image) xv_create(NULL,SERVER_IMAGE,
                XV_WIDTH,                                       BITS_WIDTH,
                XV_HEIGHT,                                      BITS_HEIGHT,
                SERVER_IMAGE_BITS,                      slowreverse_bits,
                NULL);
        (void) xv_create(VideoPanel, PANEL_BUTTON,
                PANEL_EVENT_PROC,                       VideoPanelEvent,
                PANEL_NOTIFY_PROC,                      VideoPanelProc,
                PANEL_LABEL_IMAGE,                      si,
                XV_X,                                           xv_col(VideoPanel,21),
                XV_Y,                                           xv_row(VideoPanel,0),
                XV_KEY_DATA,                            PANEL_DATA,
        3,
                NULL);
        si = (Server_image) xv_create(NULL,SERVER_IMAGE,
                XV_WIDTH,                                       BITS_WIDTH,
                XV_HEIGHT,                                      BITS_HEIGHT,
                SERVER_IMAGE_BITS,                      still_bits,
                NULL);
        (void) xv_create(VideoPanel, PANEL_BUTTON,
                PANEL_EVENT_PROC,                       VideoPanelEvent,
                PANEL_NOTIFY_PROC,                      VideoPanelProc,
                PANEL_LABEL_IMAGE,                      si,
                XV_X,                                           xv_col(VideoPanel,31),
                XV_Y,                                           xv_row(VideoPanel,0),
                XV_KEY_DATA,                            PANEL_DATA,
        4,
                NULL);
        si = (Server_image) xv_create(NULL,SERVER_IMAGE,
                XV_WIDTH,                                       BITS_WIDTH,
                XV_HEIGHT,                                      BITS_HEIGHT,
                SERVER_IMAGE_BITS,                      slowforward_bits,
                NULL);
        (void) xv_create(VideoPanel, PANEL_BUTTON,
                PANEL_EVENT_PROC,                       VideoPanelEvent,
                PANEL_NOTIFY_PROC,                      VideoPanelProc,
                PANEL_LABEL_IMAGE,                      si,
                XV_X,                                           xv_col(VideoPanel,41),
                XV_Y,                                           xv_row(VideoPanel,0),
                XV_KEY_DATA,                            PANEL_DATA,
        5,
                NULL);
        si = (Server_image) xv_create(NULL,SERVER_IMAGE,
                XV_WIDTH,                                       BITS_WIDTH,
                XV_HEIGHT,                                      BITS_HEIGHT,
                SERVER_IMAGE_BITS,                      forward_bits,
                NULL);
        (void) xv_create(VideoPanel, PANEL_BUTTON,
                PANEL_EVENT_PROC,                       VideoPanelEvent,
                PANEL_NOTIFY_PROC,                      VideoPanelProc,
                PANEL_LABEL_IMAGE,                      si,
                XV_X,                                           xv_col(VideoPanel,51),
                XV_Y,                                           xv_row(VideoPanel,0),
                XV_KEY_DATA,                            PANEL_DATA,
        6,
                NULL);
        si = (Server_image) xv_create(NULL,SERVER_IMAGE,
                XV_WIDTH,                                       BITS_WIDTH,
                XV_HEIGHT,                                      BITS_HEIGHT,
                SERVER_IMAGE_BITS,                      fastforward_bits,
                NULL);
        (void) xv_create(VideoPanel, PANEL_BUTTON,
                PANEL_EVENT_PROC,                       VideoPanelEvent,
                PANEL_NOTIFY_PROC,                      VideoPanelProc,
                PANEL_LABEL_IMAGE,                      si,
                XV_X,                                           xv_col(VideoPanel,61),
                XV_Y,                                           xv_row(VideoPanel,0),
                XV_KEY_DATA,                            PANEL_DATA,
        7,
                NULL);
        si = (Server_image) xv_create(NULL,SERVER_IMAGE,
                XV_WIDTH,                                       BITS_WIDTH,
                XV_HEIGHT,                                      BITS_HEIGHT,
                SERVER_IMAGE_BITS,                      playsegment_bits,
                NULL);
        (void) xv_create(VideoPanel, PANEL_BUTTON,
                PANEL_EVENT_PROC,                       VideoPanelEvent,
                PANEL_NOTIFY_PROC,                      VideoPanelProc,
                PANEL_LABEL_IMAGE,                      si,
                XV_X,                                           xv_col(VideoPanel,71)+5,
                XV_Y,                                           xv_row(VideoPanel,0),   
                XV_KEY_DATA,                            PANEL_DATA,
        8,
                NULL);
 
        window_fit(VideoPanel);
        return(NULL);
}


main(argc,argv)
int argc;
char *argv[];
{
 FILE *fd;
 register int n;
 static char device[10];
 Player *player;
 int model,speed;
 int stat;
 static char *filename;
 static Frame frame;
 static VideoIn video;
 Display  *VAADisplay; 
 int channel;

	xv_init(XV_INIT_ARGC_PTR_ARGV,&argc,argv,NULL);
/*
	if (argc <= 1 ) 
	 {
            fprintf(stderr,"usage: %s [ inputfilename] \n", argv[0]);
	    exit(1);
	 }

	filename= argv[0];
*/
	filename="clartest.dat";

	if ((fd = fopen(filename,"r")) ==(FILE *) NULL) 
           {
                printf("Unable to open input file\n");
                free(argv[1]);
                exit(0);
           }

	if ((fscanf(fd,"%s",device)) != 1)
		{ 
		 printf("Error Reading device name from input file\n");
		 exit(0);
		}
	if ((fscanf(fd,"%d",&model)) != 1) 
		{
		 printf("Error Reading model number from input file\n");
		 exit(0);
		}
        if ((fscanf(fd,"%d",&speed)) != 1) 
                { 
                 printf("Error Reading speed value from input file\n"); 
                 exit(0); 
                }
        if ((fscanf(fd,"%d",&StartFrame)) != 1) 
                { 
                 printf("Error Reading start frame from input file\n"); 
                 exit(0); 
                }
        if ((fscanf(fd,"%d",&EndFrame)) != 1) 
                { 
                 printf("Error Reading end frame from input file\n"); 
                 exit(0); 
                }

	if ( StartFrame > EndFrame )
		{
		printf("Start frame greater than end frame\n");
		exit(0);
		}

	
        VAAFrame = (Frame)xv_create(NULL,FRAME, 
                XV_LABEL,         "PARALLAX VIDEO CLIP", 
                FRAME_SHOW_RESIZE_CORNER,       FALSE, 
                WIN_CONSUME_EVENT,                      WIN_CONFIGURE_REQUEST, 
                NULL); 

        notify_interpose_destroy_func(VAAFrame,quit);

/* Create the control panel for the user */
 
        CreatePlayerPanel();

        VideoPlayer = (Player *) InitializeVideo(device,model,speed);
 
        if (VideoPlayer == NULL)
                exit(1);

	channel = 1;

        VideoCanvas = xv_create(VAAFrame,VIDEO_IN,
                VIDEO_CHANNEL,                 VIDEO_IN_ONE,
		VIDEO_LIVE,			TRUE,
		VIDEO_SQUEEZE,			TRUE,
                XV_X,                                   0,
                WIN_BELOW,                              VideoPanel,
                NULL);
 
        if (VideoCanvas == NULL) {
                if (Xv_VideoStatus == VIDEO_CHANNEL_IN_USE) {
                        ShowAlert("Requested channel already in use",NULL);
                }
                else if (Xv_VideoStatus == VIDEO_NO_MORE_CHANNELS) {
                        ShowAlert("Requested channel is not available",NULL);
                }
                else {
                        ShowAlert("xv_create of video canvas failed!",NULL);
                }
                return(NULL);
        }

        window_fit(VAAFrame);

        VAADisplay  = (Display *) xv_get(VideoCanvas,XV_DISPLAY);

	stat = ShowDiscSegment(VideoPlayer,StartFrame,EndFrame);

	xv_set(VAAFrame,WIN_SHOW,TRUE,NULL);


	while (TRUE) {
	      if ( PlayerFrameNumber(VideoPlayer) == EndFrame) 
		{
		 usleep(1000000);
		 xv_destroy(VideoCanvas);
		 break;
		}
	      notify_dispatch();
	      XFlush(VAADisplay);
	    }
	exit(0);
}
