/*
 * (c) Copyright 1991 Parallax Graphics Inc, All Rights Reserved
 *
 * Parallax Graphics, Inc.
 * 2500 Condensa Street
 * Santa Clara, California 95051
 *
 * $Log: player.h,v $
 * Revision 1.6  1992/06/05  18:55:10  eric
 * Moved from player.h to ../../../../include/player.h
 *
 * Revision 1.5  92/05/21  15:12:33  schen
 * check in demo19
 * 
 * Revision 1.2  91/08/19  13:09:38  eric
 * added rcs header
 * 
 *
 */

#ifdef H_ID
#ifndef lint
static char *rcsid_player_h = "@(#)$Id: player.h,v 1.6 1992/06/05 18:55:10 eric Deleted $ Parallax Graphics Inc";
#endif
#endif

/*
 *	player.h - include file for player.c
 *
 *	Written by John Malleo-Roach
 *
 */

/* Known video player types */

#define PIONEER_MODEL	0
#define SONY_MODEL		1
#define NEC_MODEL		2
#define POD_MODEL		3
#define LIVE_MODEL		4
#define FILE_MODEL		5

/* Player status codes, these are the same in all device driver files */

#define PLAYER_STATUS_UNKNOWN	0
#define PLAYER_STATUS_STOP		1
#define PLAYER_STATUS_STILL		2
#define PLAYER_STATUS_PLAY		3
#define PLAYER_STATUS_EMPTY		4

/* TYPEDEFS */

typedef struct {
	int fd;
	int model;
	int speed;
	char *device;
	int status;
} Player;

/* EXTERNALS */

extern int InitializePlayer();
extern int PlayerStatus();
extern int PlayerFrameNumber();
extern int SetPlayerAudio();
extern int SetPlayerVideo();
extern int ShowPlayerFrame();
extern int ShowPlayerSegment();
extern int PlayerPlay();
extern int PlayerReverse();
extern int PlayerStop();
extern int PlayerContinue();
extern int PlayerStill();
extern int PlayerStepForward();
extern int PlayerStepReverse();
extern int PlayerSlowForward();
extern int PlayerSlowReverse();
extern int PlayerFastForward();
extern int PlayerFastReverse();
extern int PlayerIndex();
extern int PlayerEject();

/* end of player.h */
