/*
 * (c) Copyright 1991 Parallax Graphics Inc, All Rights Reserved
 *
 * Parallax Graphics, Inc.
 * 2500 Condensa Street
 * Santa Clara, California 95051
 *
 * $Log: vaa.h,v $
 * Revision 1.6  1992/06/06  15:49:49  eric
 * Moved from vaa.h to ../../../../include//vaa.h
 *
 * Revision 1.5  92/05/21  15:12:38  schen
 * check in demo19
 * 
 * Revision 1.2  91/08/19  13:09:55  eric
 * added rcs header
 * 
 *
 */

#ifdef H_ID
#ifndef lint
static char *rcsid_vaa_h = "@(#)$Id: vaa.h,v 1.6 1992/06/06 15:49:49 eric Deleted $ Parallax Graphics Inc";
#endif
#endif

/*
 *
 *	vaa.h - Include file for vaa.c
 *
 *	Written by John Malleo-Roach
 *
 */

/* INCLUDE FILES */

#include    <xview/xview.h>
#include    <xview/panel.h>
#include    <xview/canvas.h>
#include    <xview/scrollbar.h>
#include    <xview/textsw.h>
#include    <xview/icon.h>
#include    <xview/cms.h>
#include    <xview/cursor.h>
#include    <xview/font.h>
#include    <xview/fullscreen.h>
#include    <xview/svrimage.h>
#include    <xview/icon.h>
#include    <xview/screen.h>
#include    <xview/notice.h>
#include    <X11/Xlib.h>
#include    <rasterfile.h>
#include    <pixrect/pr_io.h>

#ifdef AUDIO
#include    <multimedia/libaudio.h>
#include    <multimedia/audio_device.h>
#endif

#include	"Video.h"
#include	"player.h"

/* CONSTANTS */

/* #define DEBUG            /* Define this symbol for generating debuging code */
/* #define TRACE            /* Define this symbol for generating tracing output */

#define BOOLEAN     int
#ifndef FALSE
#define FALSE       0
#endif
#ifndef TRUE
#define TRUE        1
#endif

#define PANEL_DATA				1000
#define ITEM_DATA				1001

/* Constants for the audio device */

#define MAX_GAIN				100
#define DEFAULT_RECORD_GAIN  	50
#define DEFAULT_MONITOR_GAIN 	50

/* TYPEDEFS */

typedef struct {
	Xv_Window frame;
	VideoIn   video;
	Player   *player;
} Context;

/* EXTERNAL VARIABLES */

extern Display  *VAADisplay;		/* Local display, XView Screen and X11 Screen	*/
extern Xv_Screen VAAXVScreen;
extern int       VAAScreen;

extern Xv_Window VAAFrame;			/* Top level frame for VAA						*/
extern Xv_Window OutputFrame;		/* Frame for output panel						*/

extern Panel_item RecordVolume;		/* Pointer to panel item for record volume		*/
extern Panel_item MonitorVolume;	/* Pointer to panel item for monitor volume		*/
extern Panel_item FrameSpeed;		/* Pointer to panel item for frame speed		*/
extern Panel_item AudioOut;			/* Pointer to panel item for where audio goes	*/

extern Panel_item InterlaceButton;	/* Pointer to panel item for Deinterlace		*/
extern Panel_item VideoItem;		/* Pointer to panel item for live/still			*/
extern Panel_item FormatItem;		/* Pointer to panel item video format			*/
extern Panel_item TypeItem;			/* Pointer to panel item input type				*/

extern Panel_item FileButton;		/* Pointer to panel item for File button		*/

extern Panel_item HueItem;			/* Pointer to panel item hue adjustment			*/
extern Panel_item BrightnessItem;	/* Pointer to panel item brightness adjustment	*/
extern Panel_item ContrastItem;		/* Pointer to panel item contrast adjustment	*/
extern Panel_item SaturationItem;	/* Pointer to panel item saturation adjustment	*/

extern Context *CurrentContext;		/* Pointer to current video context				*/
extern VideoOut VideoOutput;		/* Pointer to video output object				*/

/* end of vaa.h */
