#include <X11/Xlib.h>
#include <xview/xview.h>
#include "Video.h"
#include <player.h>

static VideoIn video;	/* Pointer for video input object		*/
static Player *player;	/* Pointer to video source object		*/
Xv_Window VAAFrame;

/* Quit Notify routine */

Notify_value quit(client,status)
Notify_client client;
Destroy_status status;
{
	if (status == DESTROY_CLEANUP) {
		xv_destroy(video);
		close(player->fd);
		return(notify_next_destroy_func(client,status));
	}
	return(NOTIFY_DONE);
}

/* Sample code to display a video frame and control the video source */

main(argc, argv)
int argc;
char *argv[];
{

/* Init XView environment */

 xv_init(XV_INIT_ARGC_PTR_ARGV, &argc, argv, NULL);

/* Create window frame for video input canvas */

	VAAFrame = (Frame) xv_create(NULL,FRAME,NULL);

/* Notice window quit to destroy the video canvas */

	notify_interpose_destroy_func(VAAFrame,quit);

/* Create a simple video frame with Live Video */

	video = (VideoIn) xv_create(VAAFrame,VIDEO_IN,
		VIDEO_LIVE,			TRUE,
		VIDEO_SQUEEZE,		TRUE,
		NULL);

	if (video == NULL) {
		printf("Problem creating video canvas -- possible sync problem ---\n");
		printf("check input connection\n");
		exit(1);
	}

	window_fit(VAAFrame);

/* Create a player control device: Here, a SONY 1550 is
	connected to serial port ttya and configured at 1200 baud 
	baud rates are = 0 = default
			 1 = 1200 
			 2 = 2400
			 3 = 4800
			 4 = 9600
*/

	player = (Player *) InitializeVideo("/dev/ttya",SONY_IP,1);
	if (player == NULL) {
		printf("Couldn't initialize video player\n");
		exit(1);
	}

        xv_set(VAAFrame,WIN_SHOW,TRUE,NULL);
 
/* Display the frames 300 to 4000 */

        ShowDiscSegment(player,300,400,TRUE);

	xv_main_loop(VAAFrame);
}

